=== debian/changelog ===
fskit (1.0.3-1+genuen6u1) unstable; urgency=medium

  * New upstream version 1.0.3
  * Replace the <attr/xattr.h> header file with <sys/attr.h>
  * Add missing <attr/attributes.h> header file
  * Add the GNU_SOURCE macro in order to enable GNU extensions

 -- Aitor <aitor@genuen.org>  Sat, 20 Dec 2025 20:06:05 +0100

fskit (1.0.2-1+genuen6u1) unstable; urgency=medium

  * Build for excalibur

 -- Aitor <aitor@genuen.org>  Sat, 20 Dec 2025 19:31:18 +0100

fskit (1.0.2-1) unstable; urgency=low

  * Changed the source format to quilt.
  * Added some dependencies in debian/control.

 -- Aitor <aitor@genuen.org>  Sun, 12 Jun 2016 11:34:42 -0400

fskit (1.0.2) unstable; urgency=low

  * Updated packaging

 -- Zack Williams, University of Arizona <zdw@cs.arizona.edu>  Sun, 20 Mar 2016 21:50:56 -0700

fskit (1.0.1+142-dpkg0) dpkg; urgency=low

  * Generic dpkg packaging template

 -- Enrico Weigelt, metux IT consult <weigelt@metux.de>  Fri, 02 Jan 2015 16:19:13 +0100
