=== debian/control ===
Source: fskit
Section: admin
Priority: optional
Maintainer: Aitor <aitor@genuen.org>
Uploaders: Jude Nelson <judecn@devuan.org>
Standards-Version: 3.9.6
Homepage: http://genuen.org
Origin: Genuen
Vcs-Git: git@git.devuan.org:pkgs-utopia-substitution/fskit.git
Vcs-Browser: https://git.devuan.org/pkgs-utopia-substitution/fskit.git
X-Python-Version: >= 2.7
XS-Testsuite: autopkgtest
Build-Depends: debhelper (>= 9),
               build-essential,
               pkg-config,
               libattr1-dev,
               libfuse-dev

Package: libfskit
Architecture: linux-any
Section: libs
Pre-Depends: ${misc:PreDepends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libattr1,
         libfskit-fuse (= ${binary:Version})
Description: A SDK for creating synthetic filesystems (runtime headers).
 It provides generic code and data structures for managing filesystem
 inodes, handles, permissions, reference counting, concurrency, and so on,
 so developers can focus on filesystem-specific features. With fskit,
 a fully-featured multithreaded filesystem can be written in just over
 200 lines of code.
 .
 Project goals:
  * Stable, extensible thread-safe API.
  * Minimal runtime dependencies.
  * Multi-threaded architecture.
  * Portable architecture.
  * C linkage.

Package: libfskit-dev
Architecture: linux-any
Section: devel
Pre-Depends: ${misc:PreDepends}
Depends: ${misc:Depends},
         build-essential,
         libattr1-dev,
         libfskit (= ${binary:Version})
Description: fskit headers for development.
 It provides generic code and data structures for managing filesystem
 inodes, handles, permissions, reference counting, concurrency, and so on,
 so developers can focus on filesystem-specific features. With fskit,
 a fully-featured multithreaded filesystem can be written in just over
 200 lines of code.
 .
 Project goals:
  * Stable, extensible thread-safe API.
  * Minimal runtime dependencies.
  * Multi-threaded architecture.
  * Portable architecture.
  * C linkage.

Package: libfskit-fuse
Architecture: linux-any
Section: libs
Pre-Depends: ${misc:PreDepends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libfuse2
Description: A helper library that wraps fskit into FUSE bindings (runtime) - FUSE backend.
 It provides generic code and data structures for managing filesystem
 inodes, handles, permissions, reference counting, concurrency, and so on,
 so developers can focus on filesystem-specific features. With fskit,
 a fully-featured multithreaded filesystem can be written in just over
 200 lines of code.
 .
 Project goals:
  * Stable, extensible thread-safe API.
  * Minimal runtime dependencies.
  * Multi-threaded architecture.
  * Portable architecture.
  * C linkage.

Package: libfskit-fuse-dev
Architecture: linux-any
Section: devel
Pre-Depends: ${misc:PreDepends}
Depends: ${misc:Depends},
         build-essential,
         libfuse-dev,
         libfskit-fuse (= ${binary:Version})
Description: fskit-fuse headers for development - FUSE backend.
 It provides generic code and data structures for managing filesystem
 inodes, handles, permissions, reference counting, concurrency, and so on,
 so developers can focus on filesystem-specific features. With fskit,
 a fully-featured multithreaded filesystem can be written in just over
 200 lines of code.
 .
 Project goals:
  * Stable, extensible thread-safe API.
  * Minimal runtime dependencies.
  * Multi-threaded architecture.
  * Portable architecture.
  * C linkage.
